#include "iodefine.h"
#include "rtc.h"
#include "wdt0.h"

struct st_clock clock;

const char week[][4]={
				"SUN",
				"MON",
				"TUE",
				"WED",
				"THU",
				"FRI",
				"SAT"};

unsigned char byte2bcd(char a)
{
	return ((a/10) << 4) + a%10;
}

unsigned int bcd2int(unsigned int a)
{
	unsigned int i;
	i=((a >> 12) & 0xF)*1000
	 +((a >>  8) & 0xF)*100
	 +((a >>  4) & 0xF)*10
	 +( a        & 0xF);
	
	return i;
}

void RTC_init(void)
{
	unsigned char rtc[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	RTC_read(rtc);
	if ((rtc[0xF] & 0x10)==0x10) RTC_reset();	// obNAbvĂȂ΁AWX^
	
	clock.ss=bcd2int(rtc[0]);
	timer=clock.ss*10000000;
	clock.ye=bcd2int(rtc[6]);
	clock.mn=bcd2int(rtc[5]);
	clock.dy=bcd2int(rtc[4]);
	clock.we=rtc[3];
	clock.hh=bcd2int(rtc[2]);
	clock.mm=bcd2int(rtc[1]);
}

void RTC_reset(void)
{
	RTC_write(0x0,0x00);	// bJE^
	RTC_write(0x1,0x00);	// JE^
	RTC_write(0x2,0x12);	// JE^
	RTC_write(0x3,0x00);	// jJE^
	RTC_write(0x4,0x17);	// JE^
	RTC_write(0x5,0x02);	// JE^
	RTC_write(0x6,0x08);	// NJE^
	RTC_write(0x7,0x04);	// NX^I^v덷␳
							//   0x00 ␳Ȃ
							//   0x02 琔𑝂₷ƁAx
							//   0x7F 琔炷ƁAi
	RTC_write(0x8,0x00);	// Alarm_A WX^
	RTC_write(0x9,0x00);	// Alarm_A WX^
	RTC_write(0xA,0x00);	// Alarm_A jWX^
	RTC_write(0xB,0x00);	// Alarm_B WX^
	RTC_write(0xC,0x00);	// Alarm_B WX^
	RTC_write(0xD,0x00);	// Alarm_B jWX^
	RTC_write(0xE,0x20);
	RTC_write(0xF,0x30);
}

void RTC_write(unsigned char address,unsigned char data)
{
	int i;
	P9.DDR=0xFF;	// SDAo
	RTC_SDA=0;
	for (i=0; i<5; i++);
	RTC_SCL=0;
	for (i=0; i<5; i++);	// X^[gRfBV̂
	
	RTC_1write(0x64);
	RTC_1write(((address & 0x0F) << 4) & 0xF0);
	RTC_1write(data);

	P9.DDR=0xFF;	// SDAo
	RTC_SCL=0;
	RTC_SDA=0;
	for (i=0; i<10; i++);
	RTC_SCL=1;
	for (i=0; i<5; i++);
	RTC_SDA=1;				//XgbvRfBV̂
	for (i=0; i<10; i++);
}

char RTC_read(unsigned char data[15])
{
	unsigned char buff[15];
	char err;
	unsigned int i;
	
	P9.DDR=0xFF;	// SDAo
	RTC_SDA=0;
	for (i=0; i<5; i++);
	RTC_SCL=0;
	for (i=0; i<5; i++);	// X^[gRfBV̂
	
	err=RTC_1write(0x65);
	if (err==0)
	{
		for (i=0; i<16; i++)
		{
			buff[((i+15) & 0x0F)]=RTC_1read();
			if (i<15) RTC_ACKout();
		}
	}
	
	P9.DDR=0xFF;	// SDAo
	RTC_SCL=0;
	RTC_SDA=0;
	for (i=0; i<10; i++);
	RTC_SCL=1;
	for (i=0; i<5; i++);
	RTC_SDA=1;				//XgbvRfBV̂
	for (i=0; i<10; i++);
	
	if (err!=-1)
	{
		for (i=0; i<16; i++)
		{
			if (i<15 & buff[i]==0xff) break;
			data[i]=buff[i];
		}
	}
	return err;
}

unsigned char RTC_1read(void)
{
	int i,j;
	unsigned char data=0;
	P9.DDR=0xFE;	// SDA
	for (i=0; i<8; i++)
	{
		RTC_SCL=1;
		for (j=0; j<5; j++);
		data=data << 1;
		data=data | RTC_SDA;
		RTC_SCL=0;
		for (j=0; j<5; j++);
	}
	return data;
}

void RTC_ACKout(void)
{
	int i;
	P9.DDR=0xFF;	// SDAo
	RTC_SDA=0;
	for (i=0; i<5; i++);
	RTC_SCL=1;
	for (i=0; i<10; i++);
	RTC_SCL=0;
	for (i=0; i<5; i++);
	RTC_SDA=1;
}

char RTC_1write(unsigned char data)
{
	unsigned int i;
	char err= -1;
	
	P9.DDR=0xFF;	// SDAo
	for (i=0; i<8; i++)
	{
		if ((data & 0x80)==0x80) RTC_SDA=1;
		                    else RTC_SDA=0;

		RTC_clkout();
		data=data << 1;
	}
	P9.DDR=0xFE;	// SDA
	for (i=0; i<60000; i++)
	{
		if (RTC_SDA==0)	// ACK ҂
		{
			err=0;
			break;
		}
		
	}

	RTC_clkout();
	return err;
}

void RTC_clkout(void)
{
	int i;
	//for (i=0; i<5; i++);
	RTC_SCL=1;
	for (i=0; i<5; i++);
	RTC_SCL=0;
}
